import { createContext, useContext, useEffect, useState } from "react";

type Theme = "dark" | "light" | "system";

type ThemeProviderProps = {
  children: React.ReactNode;
  defaultTheme?: Theme;
  storageKey?: string;
};

type ThemeProviderState = {
  theme: Theme;
  setTheme: (theme: Theme) => void;
};

const initialState: ThemeProviderState = {
  theme: "system",
  setTheme: () => null,
};

const ThemeProviderContext = createContext<ThemeProviderState>(initialState);

const isLocalStorageAvailable = () => {
  return (
    typeof window !== "undefined" &&
    typeof window.localStorage !== "undefined" &&
    window.localStorage !== null
  );
};

const HEADER_COLORS = {
  light: "#ffffff",
  dark: "#0d0d0d",
};

export function ThemeProvider({
  children,
  defaultTheme = "system",
  storageKey = "vite-ui-theme",
  ...props
}: ThemeProviderProps) {
  const [theme, setTheme] = useState<Theme>(() => {
    if (isLocalStorageAvailable()) {
      const storedTheme = localStorage.getItem(storageKey) as Theme;
      return storedTheme || defaultTheme;
    }
    return defaultTheme;
  });

  useEffect(() => {
    const root = window.document.documentElement;

    root.classList.remove("light", "dark");

    if (theme === "system") {
      const systemTheme = window.matchMedia("(prefers-color-scheme: dark)")
        .matches
        ? "dark"
        : "light";

      document
        .querySelector("meta[name=theme-color]")
        ?.setAttribute(
          "content",
          HEADER_COLORS[systemTheme] || HEADER_COLORS.light
        );
      root.classList.add(systemTheme);
      return;
    }

    document
      .querySelector("meta[name=theme-color]")
      ?.setAttribute("content", HEADER_COLORS[theme] || HEADER_COLORS.light);
    root.classList.add(theme);
  }, [theme]);

  const value = {
    theme,
    setTheme: (theme: Theme) => {
      localStorage.setItem(storageKey, theme);
      setTheme(theme);
    },
  };

  return (
    <ThemeProviderContext.Provider {...props} value={value}>
      {children}
    </ThemeProviderContext.Provider>
  );
}

export const useTheme = () => {
  const context = useContext(ThemeProviderContext);

  if (context === undefined)
    throw new Error("useTheme must be used within a ThemeProvider");

  return context;
};

const isWindowAvailable = () => {
  return typeof window !== "undefined" && window !== null;
};

export const useDisplayedTheme = () => {
  const { theme, setTheme } = useTheme();

  if (theme === "system") {
    return {
      theme:
        isWindowAvailable() &&
        window.matchMedia("(prefers-color-scheme: dark)").matches
          ? "dark"
          : "light",
      setTheme,
    };
  }

  return { theme, setTheme };
};
